%{
#include <stdlib.h>
#include "symtbl.h"

#define YYSTYPE char * 
int i;
/* 	La ridefinizione di YYSTYPE puo causare problemi se si
	fa uso dell'opzione "-d" di bison per generare un file 
	include da usare con lex, in tale file verrebbe comunque definito
	YYSTYPE	come int.
	yacc e byacc non includono YYSTYPE tra i simboli definiti in y.tab.c
*/

	
struct symbol_tbl tabella_simboli;
p_symbol_tbl p_tabella=&tabella_simboli;

FILE *file_output=stdout;
FILE *file_input=stdin;
FILE *file_errori=stderr;

YYSTYPE t;
%}

%token num id relop addop mulop CONST

%%
pgm		: const_decls s_expr	
		;

const_decls	: CONST cds ';'		
		| 	
		| error ';' { yyerror("Errore nella sezione di dichiarazione costanti\n");yyerrok;}
		; 
cds		: id relop num 		{insert(p_tabella,$1,$3); fprintf(file_output,"ASS\t<-1,%s>\t-\t<0,%d>\n",$3,p_tabella->next_free_sym-1);}
		| cds ',' id relop num 	{insert(p_tabella,$3,$5); fprintf(file_output,"ASS\t<-1,%s>\t-\t<0,%d>\n",$5,p_tabella->next_free_sym-1);}
		; /* Abbiamo trasformato la grammatica in ricorsiva sinistra per mantenere l'ordine di assegnamento delle costanti */

s_expr		: s_expr addop term		{fprintf(file_output,"%s\t<0,%d>\t<0,%d>",$2,find(p_tabella,$1),find(p_tabella,$3));
						update_temp(p_tabella,$1,$3);
						$$=newtemp(p_tabella,"");
						fprintf(file_output,"\t<0,%d>\n",p_tabella->next_free_sym-1);	
						}
		| term			
		;
		

term		: term mulop factor		{fprintf(file_output,"%s\t<0,%d>\t<0,%d>",$2,find(p_tabella,$1),find(p_tabella,$3));
						update_temp(p_tabella,$1,$3);
						$$=newtemp(p_tabella,"");
						fprintf(file_output,"\t<0,%d>\n",p_tabella->next_free_sym-1);							
						}
		| factor			
		;

factor		: num				{$$=newtemp(p_tabella,$1);fprintf(file_output,"ASS\t<-1,%s>\t-\t<0,%d>\n",$1,p_tabella->next_free_sym-1);}
		| '(' s_expr ')'		{ $$=$2;}
		| id				{ i=find(p_tabella,$1);
						  if(i>=0)			
							$$=$1;
						else {	fprintf(file_errori,"ERRORE: La costante %s non e' stata dichiarata\n",$1);
							YYABORT;	}
						}	
		;	
%%

#include "lex.yy.c"


int yyerror(char *s)
{
fprintf(file_output,"%s\n",s);
}


int main(int argc,char *argv[])
{
int i,c;
p_tabella->next_free_sym=0;

while(1)
{
c=getopt(argc,argv,"O:o:e:E:vVhH");
if (c == -1) break;
switch(c)
{	
case 'O':case 'o':	file_output=fopen(optarg,"w");
			if(file_output == NULL){
			printf("Impossibile aprire file di output %s\n",optarg);
			file_output=stdout;}
		break;

case 'e':       file_errori=fopen(optarg,"w");
		if (file_errori == NULL)
			{
			file_errori=stderr;
			printf("Impossibile aprire file di errori %s\n",optarg);
			}
		break;
case 'v':case'V':	printf("%s versione del %s\n",argv[0],__DATE__);
case	'h':case 'H':	
default:		printf("USO: %s in_filename -o out_filename  -e	erro_filename\n",argv[0]);
			exit(0); 	
  }
}

if (optind < argc)
{
file_input=fopen(argv[optind],"r");
if (file_input == NULL)
	printf("Impossibile aprire file di input %s\n",argv[optind]);
else
yyin=file_input;
}	

return yyparse();


}

